---
title: right
slug: Web/CSS/right
tags:
  - CSS
  - CSS Positioning
  - CSS Property
  - Layout
  - Reference
  - Web
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>right</code></strong> <a href="/en-US/docs/Web/CSS" title="CSS">CSS</a> property participates in specifying the horizontal position of a <a href="/en-US/docs/Web/CSS/position">positioned element</a>. It has no effect on non-positioned elements.</p>

<div>{{EmbedInteractiveExample("pages/css/right.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* &lt;length&gt; values */
right: 3px;
right: 2.4em;

/* &lt;percentage&gt;s of the width of the containing block */
right: 10%;

/* Keyword value */
right: auto;

/* Global values */
right: inherit;
right: initial;
right: unset;
</pre>

<h3 id="Values">Values</h3>

<dl>
	<dt>{{cssxref("&lt;length&gt;")}}</dt>
	<dd>A negative, null, or positive {{cssxref("&lt;length&gt;")}} that represents:
	<ul>
		<li>for <em>absolutely positioned elements</em>, the distance to the right edge of the containing block.</li>
		<li>for <em>relatively positioned elements</em>, the distance that the element is moved to the left of its normal position.</li>
	</ul>
	</dd>
	<dt>{{cssxref("&lt;percentage&gt;")}}</dt>
	<dd>A {{cssxref("&lt;percentage&gt;")}} of the containing block's width.</dd>
	<dt><code>auto</code></dt>
	<dd>Specifies that:
	<ul>
		<li>for <em>absolutely positioned elements</em>, the position of the element is based on the {{Cssxref("left")}} property, while <code>width: auto</code> is treated as a width based on the content; or if <code>left</code> is also <code>auto</code>, the element is positioned where it should horizontally be positioned if it were a static element.</li>
		<li>for <em>relatively positioned elements</em>, the distance of the element from its normal position is based on the {{Cssxref("left")}} property; or if <code>left</code> is also <code>auto</code>, the element is not moved horizontally at all.</li>
	</ul>
	</dd>
	<dt><code>inherit</code></dt>
	<dd>Specifies that the value is the same as the computed value from its parent element (which might not be its containing block). This computed value is then handled as if it were a {{cssxref("&lt;length&gt;")}}, {{cssxref("&lt;percentage&gt;")}}, or the <code>auto</code> keyword.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>The effect of <code>right</code> depends on how the element is positioned (i.e., the value of the {{cssxref("position")}} property):</p>

<ul>
	<li>When <code>position</code> is set to <code>absolute</code> or <code>fixed</code>, the <code>right</code> property specifies the distance between the element's right edge and the right edge of its containing block.</li>
	<li>When <code>position</code> is set to <code>relative</code>, the <code>right</code> property specifies the distance the element's right edge is moved to the left from its normal position.</li>
	<li>When <code>position</code> is set to <code>sticky</code>, the <code>right</code> property is used to compute the sticky-constraint rectangle.</li>
	<li>When <code>position</code> is set to <code>static</code>, the <code>right</code> property has <em>no effect</em>.</li>
</ul>

<p>When both {{cssxref("left")}} and <code>right</code> are defined, if not prevented from doing so by other properties, the element will stretch to satisfy both. If the element cannot stretch to satisfy both -- for example, if a <code>width</code> is declared -- the position of the element is<em> over-constrained</em>. When this is the case, the <code>left</code> value has precedence when the container is left-to-right; the <code>right</code> value has precedence when the container is right-to-left.</p>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Absolute_and_relative_positioning_using_right">Absolute and relative positioning using right</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;div id="relative"&gt;Relatively positioned&lt;/div&gt;
&lt;div id="absolute"&gt;Absolutely positioned&lt;/div&gt;</pre>

<h4 id="CSS">CSS</h4>

<div id="example1">
<pre class="brush: css notranslate">#relative {
  width: 100px;
  height: 100px;
  background-color: #FFC7E4;
  position: relative;
  top: 20px;
  left: 20px;
}

#absolute {
  width: 100px;
  height: 100px;
  background-color: #FFD7C2;
  position: absolute;
  bottom: 10px;
  right: 20px;
}

</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Absolute_and_relative_positioning_using_right', 500, 220) }}</p>
</div>

<h3 id="Declaring_both_left_and_right">Declaring both left and right</h3>

<p>When both <code>left</code> and <code>right</code> are declared, the element will stretch to meet both, unless other constraints prevent it from doing so. If the element will not stretch or shrink to meet both. When the position of the element is<em> overspecified</em>, the precende is based on the container's direction: The <code>left</code> will take precendence if the container's direction is left-to-right. The <code>right</code> will take precedence if the container's direction is right-to-left.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;div id="parent"&gt;Parent
    &lt;div id="noWidth"&gt;No width&lt;/div&gt;
    &lt;div id="width"&gt;width: 100px&lt;/div&gt;
&lt;/div&gt;</pre>

<h4 id="CSS_2">CSS</h4>

<div id="example2">
<pre class="brush: css; notranslate">div {
  outline: 1px solid #CCCCCC;
}
#parent {
  width: 200px;
  height: 200px;
  background-color: #FFC7E4;
  position: relative;
}
/* declare both a left and a right */
#width,
#noWidth {
  background-color: #C2FFD7;
  position: absolute;
  left: 0;
  right: 0;
}
/* declare a width */
#width {
  width: 100px;
  top: 60px;
}
</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Declaring_both_left_and_right', 500, 220) }}</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('CSS3 Positioning', '#propdef-right', 'right')}}</td>
			<td>{{Spec2('CSS3 Positioning')}}</td>
			<td>Adds behavior for sticky positioning.</td>
		</tr>
		<tr>
			<td>{{SpecName('CSS2.1', 'visuren.html#propdef-right', 'right')}}</td>
			<td>{{Spec2('CSS2.1')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.right")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{cssxref("inset")}}, the shorthand for all related properties: {{cssxref("top")}}, {{cssxref("bottom")}}, {{cssxref("left")}}, and {{cssxref("right")}}</li>
	<li>The mapped logical properties: {{cssxref("inset-block-start")}}, {{cssxref("inset-block-end")}}, {{cssxref("inset-inline-start")}}, and {{cssxref("inset-inline-end")}} and the shorthands {{cssxref("inset-block")}} and {{cssxref("inset-inline")}}</li>
	<li>{{cssxref("position")}}</li>
</ul>
